/*
	pppctl.c - CGI program for controling dialup/hangup of a PPP
	link.
	Copyright 1999 Jonathan McDowell for Project Purple
*/
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <syslog.h>
#include "getcgi.h"

void doaction(void)
{
	char *action, *password;
	char **cgiparams;
	int curent;
	FILE *tmpfile;
	
	curent=0;
	action=password=NULL;
	
	cgiparams=getcgivars();
	
	while (cgiparams!=NULL && cgiparams[curent]!=NULL) {
		if (strcmp(cgiparams[curent], "action")==0)
			action=cgiparams[curent+1];
		else if (strcmp(cgiparams[curent], "password")==0)
			password=cgiparams[curent+1];
		curent += 2;
	}

	puts("Content-type: text/html\n");
	puts("<HTML><TITLE>PPP Control</TITLE></HEAD>");
	puts("<BODY BGCOLOR=#FFFFFF FGCOLOR=#000000>");

	if (password==NULL) {
		if (action && !strcmp(action, "hangup")) puts("Enter the password to hangup the PPP connection:");
		else puts("Enter the password to enable the PPP connection:");
		puts("<FORM METHOD=\"POST\" ACTION=\"pppctl\">");
		puts("<INPUT TYPE=\"password\" NAME=\"password\">");
		if (action!=NULL) printf("<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"%s\">", action);
		else puts("<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"dialup\">");
		puts("<INPUT TYPE=\"Submit\">");
		puts("</FORM>");
	} else if (!strcmp(password, "password")) {
		if (!strcmp(action, "hangup")) {
			unlink("/etc/ppp/nohangup");
			puts("Hanging up the PPP connection.");
			openlog("pppctl", 0, LOG_AUTHPRIV);
			syslog(LOG_AUTHPRIV | LOG_NOTICE, "Hanging up PPP connection");
			closelog();
		} else {
			tmpfile=fopen("/etc/ppp/dialup", "w");
			fprintf(tmpfile, "pppctl");
			fclose(tmpfile);
			tmpfile=fopen("/etc/ppp/nohangup", "w");
			fprintf(tmpfile, "pppctl");
			fclose(tmpfile);
			puts("Enabling the PPP connection.");
			openlog("pppctl", 0, LOG_AUTHPRIV);
			syslog(LOG_AUTHPRIV | LOG_NOTICE, "Enabling PPP connection");
			closelog();
		}
	} else {
		puts("Error! Invalid password!");
	}

	printf("<HR><A HREF=\"status?%lx\">Status page</A>", time(NULL));
	puts("</BODY></HTML>");

	/* Need to free more stuff here probably. */
	curent=0;
	if (cgiparams!=NULL) {
		while (cgiparams[curent]!=NULL) {
			free(cgiparams[curent]);
			++curent;
		}
		free(cgiparams);
	}
}

int main(int argc, char *argv[])
{
	srandom(time(NULL));

	doaction();

	return 0;
}
